commit 36ee59a2640712a6e24d9e27290bc5ebbef39709
Author: liuhongt <hongtao.liu@intel.com>
Date:   Wed Oct 21 13:05:16 2020 +0800

    Simplify trivial VEC_COND_EXPR in expander.
    
    gcc/ChangeLog:
    
            PR target/97506
            * config/i386/i386-expand.c (ix86_expand_sse_movcc): Move
            op_true to dest directly when op_true equals op_false.
    
    gcc/testsuite/ChangeLog:
    
            PR target/97506
            * gcc.target/i386/pr97506.c: New test.

diff --git a/gcc/config/i386/i386-expand.c b/gcc/config/i386/i386-expand.c
index 3ee332e6dc6..c6033688f51 100644
--- a/gcc/config/i386/i386-expand.c
+++ b/gcc/config/i386/i386-expand.c
@@ -3526,6 +3526,13 @@ ix86_expand_sse_movcc (rtx dest, rtx cmp, rtx op_true, rtx op_false)
   machine_mode mode = GET_MODE (dest);
   machine_mode cmpmode = GET_MODE (cmp);
 
+  /* Simplify trivial VEC_COND_EXPR to avoid ICE in pr97506.  */
+  if (rtx_equal_p (op_true, op_false))
+    {
+      emit_move_insn (dest, op_true);
+      return;
+    }
+
   /* In AVX512F the result of comparison is an integer mask.  */
   bool maskcmp = mode != cmpmode && ix86_valid_mask_cmp_mode (mode);
 
diff --git a/gcc/testsuite/gcc.target/i386/pr97506.c b/gcc/testsuite/gcc.target/i386/pr97506.c
new file mode 100644
index 00000000000..74714cfab2c
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr97506.c
@@ -0,0 +1,19 @@
+/* PR target/97506  */
+/* { dg-do compile } */
+/* { dg-options "-Og -finline-functions-called-once -fno-tree-ccp -mavx512vbmi -mavx512vl" } */
+
+typedef unsigned char __attribute__ ((__vector_size__ (16))) U;
+typedef int __attribute__ ((__vector_size__ (4))) V;
+U u;
+
+void
+bar (int i, V v)
+{
+  u += (char) i & (char) i > (U){};
+}
+
+void
+foo (void)
+{
+  bar (0, (V){});
+}

